<?php
/**
 * The tasks controller handles all saving/updateding/deleting of data from the Task section.
 * When adding a new tab it saves all the incoming inputs of the same name to $_SESSION[save]
 * When updating/eding a task it loads from database and ads to $_SESSION[save]
 * 
 * *WARNING* Contains some nasty hacks.
 * 
 * @author Nophinity
 * @version 0.1
 * @todo Add verification for user input
 * @todo Add a tree for browsing workgroup/computer/user/admin tasks
 * @todo Add support for a local scripting language to metadata rules
 *
 */
class TasksController extends Zend_Controller_Action
{
    /**
     * Redirect action to listAction
     * blank
     *
     */
    function indexAction ()
    {
        $this->listAction();
    }
    function defineViewOrder ($view)
    {
        switch (strtolower($view)) {
            case "general":
                $_SESSION["prevItem"] = "";
                break;
            case "source":
                $_SESSION["prevItem"] = "General";
                break;
            case "destination":
                $_SESSION["prevItem"] = "Source";
                break;
            case "options":
                $_SESSION["prevItem"] = "Destination";
                break;
            case "scheduler":
                $_SESSION["prevItem"] = "Options";
                break;
            case "events":
                $_SESSION["prevItem"] = "Scheduler";
                break;
            default:
                $_SESSION["prevItem"] = "";
                break;
        }
    }
    /**
     * Lists and handles deletion/search of tasks
     *
     */
    function listAction ()
    {
        $param = key($this->_getAllParams());
        if (Options::get('firstRun') == true) {
            $siteConfig = Zend::registry('siteConfig');
            $this->_redirect($siteConfig->fullUrl . 'help');
            return;
        }
        switch ($param) {
            case "all":
                $smarty = new Custom_Smarty('Tasks', 'list_all_tasks.tpl', 'mainTemplate.tpl', 'allTasksSubmenu.tpl');
                $action = $_POST['task_action'];
                if ($action == "delete") {
                    $selectedTasks = $_POST['selected_tasks'];
                    foreach ($selectedTasks as $computer => $tasks) {
                        foreach ($tasks as $key => $task) {
                            if ($task == NULL)
                                continue;
                            $taskGuid = Custom_TaskManagement::getTaskGuid($task);
                            $taskDelete = Custom_TaskManagement::getTaskGeneralStatus($taskGuid);
                            if ($taskDelete == true)
                                continue; else
                                Custom_TaskManagement::deleteTask($task);
                        }
                    }
                }
                $cs = new Custom_ComputerSelect();
                $workgroups = $cs->getWorkgroupTreeWithKeys();
                $domains = $cs->getDomainTree();
                $smarty->assign('workgroups', $workgroups);
                $smarty->assign('domains', $domains);
                $smarty->assign('listing', true);
                break;
            default:
                $smarty = new Custom_Smarty('Tasks', 'list_tasks.tpl', 'mainTemplate.tpl', 'tasksSubmenu.tpl');
                $search = $_POST["search_tasks"];
                $action = $_POST['task_action'];
                if ($action == "delete") {
                    $tasks = $_POST['selected_tasks'];
                    foreach ($tasks as $key => $task) {
                        $taskGuid = Custom_TaskManagement::getTaskGuid($task);
                        $taskDelete = Custom_TaskManagement::getTaskGeneralStatus($taskGuid);
                        if ($taskDelete == true)
                            continue; else
                            Custom_TaskManagement::deleteTask($task);
                    }
                }
                $sortby = $_GET['sortby'];
                $sortType = $_GET['sorttype'];
                $smarty->assign('sortType', $sortType == "ASC" ? "DESC" : "ASC");
                if ($sortby == "") {
                    if ($search != null) {
                        $result = Custom_TaskManagement::listTasks('task_name', true, 0, $search);
                    } else {
                        $result = Custom_TaskManagement::listTasks('id', true);
                    }
                } else {
                    $smarty->assign('sortby', $sortby);
                    if ($search != null) {
                        $result = Custom_TaskManagement::listTasks($sortby, true, 0, $search, $sortType);
                    } else {
                        try {
                            $result = Custom_TaskManagement::listTasks($sortby, true, 0, null, $sortType);
                        } catch (Exception $e) {
                            Zend::dump($e);
                        }
                    }
                }
                $smarty->assign('task_list', $result);
                $smarty->assign('listing', true);
                break;
        }
        $smarty->dumpT();
    }
    /**
     * Retrives a task object and loads it into the session
     *
     */
    function editAction ()
    {
        // ******* THIS IS A HACK ***** PLEASE CHANGE IT BEFORE FINAL RELEASE *****
        $request = $this->getRequest();
        $view = (int) $request->getParam('view');
        if ($_SESSION["edit"] != "false") {
            $_SESSION["edit"] = "true";
        }
        if ($view != NULL && is_int((int) $view)) {
            $object = Custom_TaskManagement::getTaskObject($view);
            $_SESSION["save"]["__SUPERACTION__EDIT__"] = array("id" => $view , "object" => $object);
            $this->_redirect('/tasks/add');
            return;
        }
        return;
    }
    function viewonlyAction ()
    {
        // ******* THIS IS A HACK ***** PLEASE CHANGE IT BEFORE FINAL RELEASE *****
        $request = $this->getRequest();
        $view = (int) $request->getParam('view');
        if ($_SESSION["edit"] != "false") {
            $_SESSION["edit"] = "true";
            $_SESSION["readonly"] = "true";
        }
        if ($view != NULL && is_int((int) $view)) {
            $object = Custom_TaskManagement::getUserTaskObject($view);
            $converter = new Custom_TbtToObj();
            $newObject = base64_encode(serialize($converter->convert(base64_decode($object))));
            $_SESSION["save"]["__SUPERACTION__EDIT__"] = array("id" => $view , "object" => $newObject);
            $this->_redirect('/tasks/add');
            return;
        }
        return;
    }
    /**
     * Handles the rendering/adding/editing of task objects that are retrived from the database.
     *
     */
    function addAction ()
    {
        $lang = Language::toArray(true);
        $tabNav = array("$lang[general]" => "tasks/add/view/General" , "$lang[source]" => "tasks/add/view/Source" , "$lang[destination]" => "tasks/add/view/Destination" , "$lang[options]" => "tasks/add/view/Options" , "$lang[scheduler]" => "tasks/add/view/Scheduler" , "$lang[events]" => "tasks/add/view/Events");
        $request = $this->getRequest();
        $view = "General";
        $requestView = $request->getParam('view');
        $tabNavKeys = array_keys($tabNav);
        if ($requestView == "new") {
            unset($_SESSION['save']);
            unset($_SESSION['update']);
            unset($_SESSION['edit']);
            unset($_SESSION['readonly']);
            $view = "General";
            $newTaskName = Custom_TaskManagement::makeNewTaskName();
            $newDestName = str_replace(" ", "_", $newTaskName);
            $defaultArray = array("task_general" => array("task_name" => "$newTaskName" , "dest_name" => "$newDestName") , "task_events" => array("notifyErrors" => "DEFAULT" , "notifyErrors_showWindow" => "DEFAULT" , "notifyWarnings" => "DEFAULT" , "notifyWarnings_showWindow" => "DEFAULT" , "notifySummary" => "DEFAULT" , "notifySummary_showWindow" => "DEFAULT"));
            $nid = Custom_TaskManagement::addTask(Custom_TaskManagement::makeObject($defaultArray));
            if ($_SESSION["edit"] != "true") {
                $_SESSION["edit"] = "false";
            }
            $this->_redirect("/tasks/edit/view/$nid");
            //$this->_redirect('/tasks/add');
            return;
        }
        if ($_SESSION["edit"] == "true") {
            //"History" => "tasks/add/view/History"
            $tabNav["$lang[history]"] = "tasks/add/view/History";
        }
        if (isset($_SESSION["save"]["__SUPERACTION__EDIT__"])) {
            $editAttributes = $_SESSION["save"]["__SUPERACTION__EDIT__"];
            unset($_SESSION["save"]);
            $_SESSION["save"] = Custom_TaskManagement::loadObject($editAttributes["object"]);
            $_SESSION["update"] = $editAttributes['id'];
        }
        $submitAction = $_POST["submit_action"];
        if (in_array($requestView, array_keys($tabNav)))
            $view = $requestView;
        if (isset($submitAction["cancel"])) {
            unset($_SESSION["save"]);
            unset($_SESSION["edit"]);
            unset($_SESSION['prevItem']);
            $this->_redirect("/tasks");
            return;
        }
        $saveName = $_POST["save_name"];
        if (isset($submitAction["next"])) {
            $saveExtras = explode(' ', $_POST["save_extras"]);
            foreach ($saveExtras as $savePath) {
                $addToArray = array("$savePath" => $_POST["$savePath"]);
                $_POST["$saveName"] = array_merge($_POST["$saveName"], $addToArray);
            }
            if ($_SESSION["readonly"] != "true")
                $this->saveTaskOptions($saveName);
            $view = $_POST['next'];
        }
        if (isset($submitAction["next"]))
            $this->defineViewOrder($view);
        if (isset($submitAction["back"]) && $_SESSION['prevItem'] != "") {
            $saveExtras = explode(' ', $_POST["save_extras"]);
            foreach ($saveExtras as $savePath) {
                $addToArray = array("$savePath" => $_POST["$savePath"]);
                $_POST["$saveName"] = array_merge($_POST["$saveName"], $addToArray);
            }
            $this->saveTaskOptions($saveName);
            $view = $_SESSION['prevItem'];
            $this->defineViewOrder($_SESSION['prevItem']);
        }
        if (isset($submitAction["finish"])) {
            $saveExtras = explode(' ', $_POST["save_extras"]);
            foreach ($saveExtras as $savePath) {
                $addToArray = array("$savePath" => $_POST["$savePath"]);
                $_POST["$saveName"] = array_merge($_POST["$saveName"], $addToArray);
            }
            $this->saveTaskOptions($saveName);
            $this->finishTask();
            unset($_SESSION["edit"]);
            unset($_SESSION['prevItem']);
            return;
        }
        $cView = strtolower($view);
        $smarty = new Custom_Smarty("Tasks", "tabWindows/new_task_${cView}.tpl", 'mainTemplate.tpl', 'tasksSubmenu.tpl');
        $nextItem = $tabNavKeys[(array_search($view, $tabNavKeys) + 1)];
        if ($_SESSION['edit'] !== "false") {
            if ($_SESSION['readonly'] == "true")
                $smarty->assign("actionName", $lang["viewTask"]); else
                $smarty->assign('actionName', $lang["editTask"]);
        } else {
            $smarty->assign("actionName", $lang["newTask"]);
        }
        $smarty->assign('tabNav', $tabNav);
        $smarty->assign("current", $view);
        if ($nextItem == "" && $view != "General")
            $nextItem = "Events";
        $smarty->assign('nextItem', $nextItem);
        $smarty->assign('prevItem', $_SESSION['prevItem']);
        $this->assignOptions(&$smarty, "$cView");
        if ($view == "History") {
            $db = Zend::registry('dbController');
            if ($_POST["Load"] != "") {
                //Get Hist Data
                $loadHist = $_POST["loadTask"];
                $select = $db->select()->from('task_history')->where('hist_id = ?', $loadHist);
                $res = $db->fetchRow($select);
                $_SESSION['save'] = Custom_TaskManagement::loadObject($res["data"]);
                $_SESSION["save"]["History"] = $_POST["loadTask"];
                $_SESSION["save"]["noSave"] = true;
                $smarty->assign('redirect', true);
            }
            $select = $db->select()->from('task_history')->where('task_id = ?', $_SESSION["update"])->order("insert_date DESC");
            $result = $db->fetchAll($select);
            $smarty->assign('currentHist', $_SESSION["save"]["History"]);
            $smarty->assign('taskHistory', $result);
            //Zend::dump($_SESSION);
        }
        if ($view == "General") {
            $rules = new Custom_ComputerSelect();
            $id = $_SESSION["update"];
            if ($id != "") {
                $smarty->assign('task_rules', $rules->getRulesTree($id));
                $smarty->assign("task_id", $id);
                $taskGuid = Custom_TaskManagement::getTaskGuid($id);
                $smarty->assign("task_guid", $taskGuid);
            }
        }
        if ($view == "Source") {
            $plugins = Custom_TaskManagement::getPlugins();
            $lSearchMasks = array(array("name" => "Productivity Files" , value => "*.cdt;*.cpt;*.csv;*.dbf;*.doc;*.dot;*.dwq;*.indd;*.indt;*.mpp;*.mst;*.pat;*.pdf;*.pmd;*.pps;*.ppt;*.pub;*.qpw;*.qxd;*.qxt;*.rtf;*.scx;*.swc;*.sxd;*.sxi;*.sxw;*.vsd;*.wcm;*.wks;*.wpd;*.wpg;*.wps;*.wpt;*.cls;*.xls;*.odt;*.odp;*.ods;*.docx;*.docm;*.dotx;*.dotm;*.xlsx;*.xlsm;*.xltx;*.xltm;*.xlsb;*.xlam;*.pptx;*.pptm;*.potx;*.potm;*.ppam;*.ppsx;*.ppsm") , array("name" => "Picture Files - Common" , value => "*.bmp;*.gif;*.jpeg;*.jpg;*.png;*.psd;*.psp;*.tif;*.ai;*.drw;*.dxf;*.eps;*.ps;*.psd;*.svg;*.mng;*.pct;*.crd") , array("name" => "Picture Files - All" , value => "*.2bp;*.2d;*.3d;*.3d2;*.3d4;*.3da;*.3df;*.3dl;*.3dm;*.3dmf;*.3ds;*.3dx;*.8pbs;*.ac5;*.ac6;*.acr;*.act;*.adc;*.adi;*.afp;*.agp;*.ai;*.ais;*.amu;*.anm;*.arr;*.art;*.art;*.awd;*.bip;*.blend;*.blz;*.bmc;*.bmc;*.bmf;*.bmp;*.br3;*.br4;*.br5;*.btf;*.btif;*.c4;*.c4d;*.cag;*.cal;*.cal;*.cals;*.cam;*.catpart;*.cdr;*.cdt;*.ce;*.cel;*.cgm;*.cil;*.cin;*.cld;*.cmx;*.cnv;*.cpc;*.cph;*.cps;*.cpt;*.cr2;*.cr2;*.crw;*.csf;*.cut;*.cv5;*.cvi;*.cvi;*.cvs;*.cvx;*.dae;*.dcm;*.dcr;*.dcs;*.dcx;*.ddb;*.ddrw;*.dds;*.des;*.des;*.dgn;*.dib;*.djvu;*.dng;*.dpd;*.dpp;*.dpr;*.dpx;*.drw;*.drw;*.dwg;*.dxb;*.dxf;*.emf;*.emz;*.eps;*.exif;*.fac;*.face;*.fal;*.fax;*.fbm;*.fbx;*.fh9;*.fhd;*.fits;*.flx;*.fm;*.fpx;*.fs;*.gds;*.gem;*.gem;*.gfb;*.gif;*.gks;*.gmf;*.graffle;*.gry;*.gsd;*.gsm;*.hcx;*.hdp;*.hdr;*.hf;*.hip;*.hipnc;*.hmk;*.hr;*.hrf;*.iam;*.ic1;*.ic2;*.ic3;*.ica;*.icb;*.icn;*.icon;*.idw;*.iff;*.iges;*.igs;*.ilbm;*.imj;*.indd;*.info;*.ink;*.ink;*.inx;*.ipt;*.ithmb;*.ivr;*.j2c;*.j2k;*.jas;*.jbf;*.jbig;*.jfi;*.jfif;*.jif;*.jiff;*.jp2;*.jpc;*.jpe;*.jpeg;*.jpf;*.jpg;*.jpw;*.jpx;*.jtf;*.kdc;*.kdk;*.kfx;*.kodak;*.kpg;*.lbm;*.lin;*.lwo;*.lws;*.mac;*.mag;*.max;*.max;*.max;*.mbm;*.mcs;*.mcx;*.mdi;*.meb;*.mesh;*.mgf;*.mgs;*.mic;*.mip;*.mix;*.mix;*.mma;*.mng;*.mrb;*.mrw;*.msk;*.msp;*.nav;*.ncd;*.nef;*.neo;*.nff;*.nif;*.ntc;*.ntf;*.obj;*.odc;*.odg;*.odi;*.odif;*.off;*.ola;*.omf;*.opf;*.orf;*.ota;*.otb;*.otc;*.otg;*.oti;*.ovw;*.p65;*.pac;*.pal;*.pat;*.pat;*.pbm;*.pc1;*.pc2;*.pc3;*.pc6;*.pc7;*.pcd;*.pct;*.pcx;*.pd;*.pdd;*.pdf;*.pdg;*.pe4;*.pe4;*.pef;*.pfr;*.pgm;*.pi1;*.pi2;*.pi3;*.pi4;*.pi5;*.pi6;*.pic;*.picnc;*.pict;*.pictclipping;*.pla;*.pln;*.plt;*.ply;*.pm;*.pm3;*.pm4;*.pm5;*.pm6;*.png;*.pnt;*.pov;*.pov;*.pp2;*.ppm;*.ppp;*.prn;*.prw;*.ps;*.psb;*.psd;*.psf;*.psg;*.psid;*.psp;*.pspimage;*.ptx;*.ptx;*.pwp;*.pws;*.px;*.pz3;*.pzz;*.qif;*.qti;*.qtif;*.qxd;*.qxp;*.qxt;*.raf;*.ras;*.raw;*.ray;*.rds;*.rgb;*.rgb;*.rif;*.rix;*.rle;*.sar;*.sbk;*.scg;*.sci;*.scp;*.sct;*.scu;*.scv;*.sda;*.sdb;*.sdm;*.sdr;*.sff;*.sfw;*.sgi;*.shg;*.shp;*.si;*.sid;*.sig;*.sim;*.skp;*.sldasm;*.slddrw;*.sldprt;*.smp;*.sp;*.spc;*.spiff;*.spp;*.spu;*.sr;*.srf;*.std;*.sto;*.stp;*.sun;*.suniff;*.sup;*.svg;*.sxd;*.taac;*.tcd;*.tcw;*.tddd;*.tex;*.tfw;*.tga;*.thm;*.thm;*.thumb;*.tif;*.tiff;*.tjp;*.tlc;*.tn1;*.tn2;*.tn3;*.tny;*.trif;*.u;*.ufo;*.urt;*.vv;*.v3d;*.vda;*.vff;*.vic;*.viff;*.vis;*.vna;*.vsd;*.vss;*.vst;*.vst;*.vue;*.wbmp;*.wdp;*.web;*.wgs;*.wi;*.wic;*.wmf;*.wmp;*.wnk;*.wpg;*.wrl;*.wrp;*.wrz;*.x3d;*.xar;*.xbm;*.xcf;*.xdw;*.xif;*.xof;*.xpm;*.xsi;*.xwd;*.xws;*.yal;*.yaodl;*.ydl;*.yuv;*.zgm;*.zno;*.zt") , array("name" => "Music Files - Common" , value => "*.aac;*.aif;*.iff;*.m3u;*.mod;*.mid;*.midi;*.mp3;*.mpa;*.ra;*.ram;*.wav;*.wma") , array("name" => "Music Files - All" , value => "*.669;*.4mp;*.6cm;*.8cm;*.8med;*.8svx;*.aa3;*.aac;*.abc;*.ac3;*.acd;*.act;*.ahx;*.aif;*.aifc;*.aiff;*.ais;*.akp;*.al;*.alaw;*.all;*.amr;*.ams;*.ams;*.ape;*.ase;*.au;*.aud;*.aup;*.avr;*.band;*.bap;*.bdd;*.box;*.bwf;*.c01;*.caf;*.cda;*.cdr;*.cel;*.cmf;*.copy;*.cpr;*.csh;*.cwp;*.d00;*.d01;*.dcf;*.dcm;*.dct;*.dewf;*.df2;*.dfc;*.dig;*.dig;*.dls;*.dm;*.dmf;*.dsf;*.dsm;*.dsp;*.dss;*.dtm;*.dvf;*.DWD;*.ear;*.efa;*.efe;*.efk;*.efq;*.efs;*.efv;*.emd;*.esps;*.f2r;*.f32;*.f3r;*.f64;*.far;*.fff;*.flac;*.flp;*.fsm;*.fzb;*.fzf;*.fzv;*.g721;*.g723;*.g726;*.gig;*.gp5;*.gsm;*.gsm;*.ics;*.iff;*.ins;*.ins;*.it;*.iti;*.its;*.jam;*.k25;*.k26;*.kar;*.kin;*.kmp;*.koz;*.koz;*.krz;*.ksc;*.ksf;*.ktp;*.lso;*.lvp;*.m3u;*.m4a;*.m4b;*.m4p;*.m4r;*.ma1;*.mdl;*.med;*.mid;*.midi;*.miniusf;*.mka;*.mmf;*.mod;*.mp1;*.mp2;*.mp3;*.mpa;*.mpc;*.mpd;*.mpga;*.mpu;*.mp_;*.msv;*.mt2;*.mte;*.mti;*.mtm;*.mtp;*.mts;*.mus;*.mws;*.nap;*.nrt;*.nsa;*.nsf;*.nst;*.ntn;*.nwc;*.odm;*.ogg;*.okt;*.omf;*.omg;*.pac;*.pat;*.pbf;*.pca;*.pcm;*.phy;*.pla;*.pls;*.pna;*.prg;*.prg;*.psm;*.ptm;*.pts;*.pvc;*.qcp;*.ra;*.ram;*.raw;*.rbs;*.rfl;*.rmf;*.rmi;*.rmx;*.rng;*.rol;*.rsn;*.rti;*.rtm;*.rts;*.s3i;*.s3m;*.saf;*.sam;*.sb;*.sbi;*.sbk;*.sc2;*.sd;*.sd;*.sd2;*.sds;*.sdx;*.sf;*.sf2;*.sfk;*.sfl;*.shn;*.sib;*.sid;*.smf;*.smp;*.snd;*.snd;*.snd;*.sng;*.sou;*.sppack;*.sprg;*.sseq;*.ssnd;*.stm;*.stx;*.svx;*.sw;*.swa;*.syh;*.syw;*.syx;*.td0;*.tfmx;*.thx;*.toc;*.tsp;*.txw;*.ub;*.ulaw;*.ult;*.ulw;*.uni;*.usf;*.usflib;*.uw;*.uwf;*.vag;*.val;*.vmd;*.vmf;*.vmf;*.voc;*.voi;*.vox;*.vqf;*.vrf;*.vyf;*.w01;*.wav;*.wave;*.wax;*.wfb;*.wfd;*.wfp;*.wma;*.wow;*.wpk;*.wproj;*.wrk;*.wus;*.wut;*.wv;*.wvc;*.wwu;*.xfs;*.xi;*.xm;*.xmf;*.xmi;*.xp;*.xt;*.zvd") , array("name" => "Video Files - Common" , value => "*.asf;*.asx;*.avi;*.mov;*.mp4;*.mpg;*.qt;*.rm;*.swf;*.wmv") , array("name" => "Video Files - All" , value => "*.3g2;*.3gp;*.3gp2;*.3gpp;*.3mm;*.60d;*.aep;*.ajp;*.amv;*.asf;*.asx;*.avb;*.avi;*.avs;*.bik;*.bix;*.box;*.byu;*.camrec;*.cvc;*.d2v;*.dat;*.dce;*.dif;*.dir;*.divx;*.dmb;*.dpg;*.dv;*.dvr-ms;*.dxr;*.eye;*.fcp;*.flc;*.fli;*.flv;*.flx;*.gl;*.grasp;*.gvi;*.gvp;*.ifo;*.imovieproj;*.imovieproject;*.ivf;*.ivs;*.izz;*.izzy;*.lsf;*.lsx;*.m1v;*.m21;*.m2v;*.m4e;*.m4u;*.m4v;*.mjp;*.mkv;*.mod;*.moov;*.mov;*.movie;*.mp21;*.mp4;*.mpe;*.mpeg;*.mpg;*.mpv2;*.mqv;*.msh;*.mswmm;*.mvb;*.mvc;*.nsv;*.nvc;*.ogm;*.pds;*.piv;*.playlist;*.pro;*.prproj;*.prx;*.qt;*.qtch;*.qtz;*.rm;*.rmvb;*.rp;*.rts;*.rts;*.sbk;*.scm;*.scm;*.scn;*.sfvidcap;*.smil;*.smv;*.spl;*.srt;*.ssm;*.str;*.svi;*.swf;*.swi;*.tda3mt;*.tivo;*.ts;*.vdo;*.veg;*.vf;*.vfw;*.vid;*.viewlet;*.viv;*.vivo;*.vob;*.vp6;*.vp7;*.vro;*.w32;*.wcp;*.wm;*.wmd;*.wmv;*.wmx;*.wvx;*.yuv") , array("name" => "Financial Files" , value => "*.mbf;*.mny;*.ofc;*.q00;*.q01;*.q02;*.q03;*.q04;*.q05;*.q98;*.qba;*.qbb;*.qbi;*.qbw;*.qbx;*.qdb;*.qdf;*.qdt;*.qif;*.t01;*.t02;*.t03;*.t04;*.t05;*.ta0;*.ta1;*.ta2;*.ta3;*.ta4;*.ta5;*.ta6;*.ta7;*.ta8;*.ta9;*.tax"));
            $smarty->assign("lSearchMasks", $lSearchMasks);
            $smarty->assign('plugins', $plugins);
        }
        if ($view == "Destination") {
            $storePaths = Options::get('storePaths');
            $smarty->assign('storePaths', $storePaths);
        }
        $smarty->assign("task_id", $_SESSION['update']);
        $smarty->assign('edit', $_SESSION["edit"]);
        $smarty->assign('readonly', $_SESSION['readonly']);
        $smarty->assign('saved_data', $_SESSION["save"]);
        $smarty->dumpT();
    }
    /**
     * Saves the certain values of a tab into the session
     *
     * @param string $saveName
     * @return int
     */
    function saveTaskOptions ($saveName)
    {
        $addValues = $_POST[$saveName];
        $_SESSION["save"][$saveName] = $addValues;
        return 1;
    }
    /**
     * Retrives the options for a certain tab from the database
     *
     * @param string $taskName
     * @return array
     */
    function getOptions ($taskName)
    {
        $sTaskName = "task_$taskName";
        $options = $_SESSION["save"][$sTaskName];
        return $options;
    }
    /**
     * Assigns options from the _SESSION to the smarty template
     *
     * @param Smarty $smarty
     * @param string $taskName
     */
    function assignOptions ($smarty, $taskName)
    {
        $options = $this->getOptions($taskName);
        foreach ($options as $tName => $tValue)
            $smarty->assign("$tName", $tValue);
    }
    /**
     * Adds or updates the task in the database
     *
     */
    function finishTask ()
    {
        $object = Custom_TaskManagement::makeObject($_SESSION['save']);
        if (isset($_SESSION["update"])) {
            $id = $_SESSION["update"];
            unset($_SESSION["update"]);
            $result = Custom_TaskManagement::updateTask($id, $object);
            if ($_SESSION["edit"] == "true") {
                // Handle HISTORY stuff :D
                $row = array("task_id" => "$id" , "data" => $object , "insert_date" => time(0) , "type" => "edit");
                $db = Zend::registry('dbController');
                try {
                    $db->insert('task_history', $row);
                } catch (Exception $e) {
                    Zend::dump($e);
                }
            } else {
                // Handle HISTORY stuff :D
                $row = array("task_id" => "$id" , "data" => $object , "insert_date" => time(0) , "type" => "original");
                $db = Zend::registry('dbController');
                try {
                    $db->insert('task_history', $row);
                } catch (Exception $e) {
                    Zend::dump($e);
                }
            }
        } else {
            $result = Custom_TaskManagement::addTask($object);
        }
        if ($result == - 1) {
            $this->_redirect('/tasks/add');
            // PRINT ERROR THAT TASK ALLREADY EXISTS HERE
            return;
        }
        $this->_redirect("/tasks");
        unset($_SESSION["save"]);
        return;
    }
    function rulesAction ()
    {
        $smarty = new Custom_Smarty("Task Rules", NULL, "ruleAddPopup.tpl", NULL);
        $request = $this->getRequest();
        $task_id = (int) $request->getParam('task_id');
        $cs = new Custom_ComputerSelect();
        $smarty->assign('workgroups', $cs->getWorkgroupTree());
        $smarty->assign('domains', $cs->getDomainTree());
        if ($request->getParam("delete") != "") {
            $rules = new Custom_RuleManagement($task_id);
            $rules->deleteRule($request->getParam('delete'));
            $this->_redirect("/tasks/add");
            return;
        }
        $smarty->assign("task_id", $task_id);
        if ($request->getParam("edit") != "") {
            $task_id = $_SESSION['update'];
            $smarty = new Custom_Smarty("Task Rules", NULL, "ruleEditPopup.tpl", NULL);
            $rules = new Custom_RuleManagement($task_id);
            $smarty->assign('workgroups', $cs->getWorkgroupTree());
            $smarty->assign('domains', $cs->getDomainTree());
            $vars = $rules->getRule($request->getParam('edit'));
            $smarty->assign('vars', $vars);
            $values = $_POST["select"];
            if ($_POST["save"] == "Apply") {
                $rules->updateRule($request->getParam('edit'), $values["user_name"], $values["workgroup_name"], $values["domain_name"], $values["computer_name"], $values['ip']);
                $smarty->assign("close_window", true);
                $smarty->dumpT();
                //                $this->_redirect("/tasks/rules/edit/".$request->getParam('edit'));
                return;
            }
            $smarty->dumpT();
            return;
        }
        if (! $task_id) {
            die("Task ID Missing!");
        }
        ;
        $values = $_POST["select"];
        if ($_POST["save"] == "Apply") {
            $ruleManagement = new Custom_RuleManagement($task_id);
            $ruleManagement->addRule($values["user_name"], $values["workgroup_name"], $values["domain_name"], $values["computer_name"], $values['ip']);            
            $smarty->assign("close_window", true);
        }
        $smarty->dumpT();
    }
}