<?php
$db = Zend::registry('dbController');
$select = $db->select()->from('task_status')->where('next_run_time != ?', 'Never.');
$select->where('next_run_time != ?', 'At Next Startup.');
$select->where('next_run_time != ?', 'At ShutDown.');
$select->where('missed = ?', 'no');
$tasks = $db->fetchAll($select);
foreach ($tasks as $task) {
    //Explode the date
    $dateTime = $task['next_run_time'];
    list ($date, $time) = explode(' at ', $dateTime);
    list ($month, $day, $year) = explode('/', $date);
    if ($time == "Startup" || $time == "ShutDown") {
        continue;
    }
    list ($hour, $minute, $sec) = explode(':', $time);
    $sec = str_replace("o'clock", "", $sec);
    $dTime = mktime($hour, $minute, $sec, $month, $day, $year);
    $cTime = time();
    if ($cTime > $dTime) {
        Logger::Log(10, 3, $task['task_guid'], $task['computer_guid']);
        $db->update('task_status', array('missed' => 'yes'), $db->quoteInto('sid = ?', $task['sid']));
    }
}