<?php
/**
 * The main initalization script starts and predefines all the variables.
 *
 * @author Nophinity
 * @package TBES
 */
error_reporting(E_ERROR);
set_magic_quotes_runtime(false);
$currentPath = str_replace('init.php', '', __FILE__);
$includePaths = array($currentPath . "library");

foreach ($includePaths as $addPath) {
    $includePath = get_include_path();
    set_include_path($includePath . PATH_SEPARATOR . $addPath);
}
include_once ("Zend.php");
set_time_limit(600);
Zend::loadClass('Zend_Config_Ini');
Zend::loadClass('Zend_Controller_Front');
Zend::loadClass('Zend_Db');
Zend::loadClass('Zend_Mail');
if (NO_CUSTOM_SMARTY !== true) {
    Zend::loadClass('Custom_Smarty');
}
Zend::loadClass('Custom_TaskManagement');
Zend::loadClass('Custom_ComputerSelect');
Zend::loadClass('Custom_Debug');
Zend::loadClass('Custom_RuleManagement');
Zend::loadClass('Custom_XMLProcedures');
Zend::loadClass('Custom_XMLSchemas');
Zend::loadClass('Custom_XMLQuerys');
Zend::loadClass('Custom_XMLResponse');
Zend::loadClass('Custom_ObjToTbt');
Zend::loadClass('Custom_TbtToObj');
Zend::loadClass('Custom_Mail');
Zend::loadClass('Logger');
Zend::loadClass('Options');
Zend::loadClass('CompSpace');
Zend::loadClass('Language');
//echo(dirname(__FILE__));
//echo("WTF".__FILE__);
$scriptDir = dirname(__FILE__);
try {
    $databaseConfig = new Zend_Config_Ini($scriptDir . '/config/config.ini', 'database');
    $siteConfig = new Zend_Config_Ini($scriptDir . '/config/config.ini', 'site');
} catch (Exception $e) {
    header('Location: ./install');
    return;
}
$DEBUG_MODE = $siteConfig->debugMode;
$siteTimeZone = $siteConfig->timezone;
$siteLanguage = $siteConfig->language;
$siteTheme = $siteConfig->theme;
date_default_timezone_set($siteTimeZone);
$siteWebRoot = $siteConfig->webRoot;
//$siteBaseUrl = $siteConfig->baseUrl;
$siteController = Zend_Controller_Front::getInstance();
$siteController->setParam('useModules', false);
//$siteController->setBaseUrl($siteBaseUrl);
$siteController->setControllerDirectory($scriptDir . "/controllers");
$siteController->setDefaultController('Tasks');
if ($DEBUG_MODE == 1) {
    error_reporting(E_ALL);
    $siteController->throwExceptions(true);
}
switch ($databaseConfig->engine) {
    case "mysql":
        $dbParams = array('host' => $databaseConfig->host , 'username' => $databaseConfig->user , 'password' => $databaseConfig->pass , 'dbname' => $databaseConfig->dbname);
        $databaseController = Zend_Db::factory('PDO_MYSQL', $dbParams);
        break;
    case "sqlite":
        $databaseController = Zend_Db::factory('PDO_SQLITE', array("dsnprefix" => "sqlite3" , "dbname" => $scriptDir . "/database/titanbackupeserver.sqlite"));
        break;
    default:
        die("Invalid PDO Class");
        break;
}
Zend::register('databaseConfig', $databaseConfig);
Zend::register('siteConfig', $siteConfig);
Zend::register('siteController', $siteController);
Zend::register('dbController', $databaseController);
Zend::register('debugMode', $DEBUG_MODE);
session_start();
session_name('TBES');
$_SESSION["lang"] = $siteConfig->language;
$_SESSION["theme"] = $siteConfig->theme;
/* THIS IS TEMPORARY PLEASE ADJUST / DELETE */
$_SESSION["userName"] = "admin";
$_SESSION["isAdmin"] = true;
if ($DEBUG_MODE == "box") {
    $databaseController->getProfiler()->setEnabled(true);
}
Options::setDefaults(false);
$_SESSION['langString'] = Language::toArray(true);

/* Logger Crap */

