<?php
class Custom_RuleManagement
{
    function __construct ($task_id)
    {
        $this->task_id = $task_id;
        $this->db = Zend::registry("dbController");
    }
    function addRule ($user_match = NULL, $workgroup_match = NULL, $domain_match = NULL, $computer_match = NULL, $ip_match = NULL, $taskID = NULL)
    {
        $task_id = $this->task_id;
        if ($taskID !== NULL)
            $task_id = $taskID;
        $row = array("user_match" => $user_match , "workgroup_match" => $workgroup_match , "domain_match" => $domain_match , "computer_match" => $computer_match , "ip_match" => $ip_match , "task_id" => "$task_id");
        foreach ($row as $key => $value) {
            if ($value == "")
                $row[$key] = NULL;
        }
        $this->db->insert('rules', $row);
        return $this->db->lastInsertId();
    }
    function deleteRule ($id)
    {
        // Get rule task_id
        $select = $this->db->select();
        $where = $this->db->quoteInto("rule_id = ?", $id);
        $db = $this->db;
        $select->from('rules')->where($where);
        $fetchRows = $db->fetchAll($select);
        $cs = new Custom_ComputerSelect();
        foreach ($fetchRows as $rule) {
            $taskID = $rule['task_id'];
            $comps = $cs->getTaskComputers($taskID);
            $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $taskID));
            $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $taskID));
            foreach ($comps as $computer) {
                if ($computer == "" || $taskID == "")
                    continue;
                $xml = "<serverCommand><name>ADMIN-TASK-DELETE</name><tasks><task><taskName>$taskName[0]</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                $insertRow = array("comp_guid" => $computer , "cmd_name" => "ADMIN_TASK_DELETE" , "status" => "pending" , "xml" => $xml , "task_id" => $taskID);
                $db->insert('cmdqueue', $insertRow);
            }
        }
        $this->db->delete('rules', $where);
    }
    function getRule ($id)
    {
        $vars = $this->db->fetchRow("SELECT * FROM rules WHERE rule_id = $id");
        return $vars;
    }
    function updateRule ($rule_id, $user_match = NULL, $workgroup_match = NULL, $domain_match = NULL, $computer_match = NULL, $ip_match = NULL)
    {
        $this->deleteRule($rule_id);
        $this->addRule($user_match, $workgroup_match, $domain_match, $computer_match, $ip_match, $this->task_id);
    }
}