<?php
class Custom_XMLProcedures
{
    public static function printRincedXML ($xml, $return = false)
    {
        if (is_string($xml)) {
            echo ($xml);
            return;
        }
        $domxml = new DOMDocument('1.0', 'UTF-8');
        $domxml->formatOutput = 1;
        $domnode = dom_import_simplexml($xml);
        $domnode = $domxml->importNode($domnode, true);
        $domnode = $domxml->appendChild($domnode);
        if ($return) {
            return $domxml->saveXML();
        }
        {
            echo ($domxml->saveXML());
        }
        return $domxml->saveXML();
    }
    public function cmdRequest (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = (string) $xml->clientID;
        $select = $db->select()->from('cmdqueue')->where('comp_guid = ?', $clientID)->where('status = ?', 'pending')->order('id ASC');
        $result = $db->fetchAssoc($select);
        if (! $this->checkRegistration($clientID)) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        // Update Computer Version
        try {
            $db->update("computers", array("client_version" => "$xml->clientVersion"), $db->quoteInto('comp_guid = ?', "$xml->clientID"));
        } catch (Exception $e) {
            var_dump($e);
        }
        // Update computer last check in time
        $cTime = time(0);
        $cRow = array("last_update" => time(0));
        $cWhere = $db->quoteInto("comp_guid = ?", $clientID);
        $db->update('computers', $cRow, $cWhere);
        // Update computer last check in time
        if (count($result) == 0) {
            $schema = "";
            $schema .= constant("Custom_XMLSchemas::XML_RESPONSE_NO_COMMAND");
            $Send = simplexml_load_string($schema);
            $Send->refresh = Options::get('refresh_time');
            $Send->clientID = (string) $xml->clientID;
            self::printRincedXML($Send);
            return;
        }
        $schema = Custom_XMLSchemas::getHeader();
        foreach ($result as $row) {
            ++ $current;
            $taskType = $row["cmd_name"];
            if (strlen($row["xml"]) > 0 && $taskType != "ADMIN_TASK_NEW" && $taskType != "REFRESH") {
                $taskSchema = $row["xml"];
                $newCommand = simplexml_load_string($taskSchema);
                Custom_XMLSchemas::simplexml_append($schema, $newCommand);
            } else {
                $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_$taskType");
                $newCommand = simplexml_load_string($taskSchema);
                Custom_XMLSchemas::simplexml_append($schema, $newCommand);
                $xmlRow = & $schema->serverCommand[($current - 1)];
                $xmlRow->name = str_replace("_", "-", $row["cmd_name"]);
                if ($taskType == "ADMIN_TASK_NEW") {
                    $taskData = Custom_TaskManagement::loadObject(Custom_TaskManagement::getTaskObject($row["task_id"]));
                    $xmlRow->tasks->task->addChild('taskID', $taskData['uuid']);
                    $taskStatus = Custom_TaskManagement::getTaskStatus($taskData["uuid"], $clientID);
                    $xmlRow->tasks->task->taskName = htmlentities($taskData["task_general"]["task_name"]);
                    $decodedObj = new Custom_ObjToTbt();
                    $computerDetails = $db->fetchRow('SELECT * FROM computers WHERE comp_guid = :id', array("id" => "$clientID"));
                    $decodedObj->computerName = $computerDetails["computer_name"];
                    $decodedObj->workgroup = $computerDetails["workgroup"];
                    $xmlRow->tasks->task->taskData = base64_encode($decodedObj->convert(Custom_TaskManagement::makeObject($taskData), true, $taskStatus["last_run_time"], array("computer" => "$clientID","$taskData[uuid]")));
                }
                if ($taskType == "REFRESH") {
                    if ($row['task_id'] === NULL) {
                        $xmlRow->addChild('noTasks', 'true');
                    }
                    if ($row['task_id'] !== NULL) {
                        $taskData = Custom_TaskManagement::loadObject(Custom_TaskManagement::getTaskObject($row["task_id"]));
                        $xmlRow->tasks->task->addChild('taskID', $taskData['uuid']);
                        $xmlRow->tasks->task->taskName = htmlentities($taskData["task_general"]["task_name"]);
                        $decodedObj = new Custom_ObjToTbt();
                        $computerDetails = $db->fetchRow('SELECT * FROM computers WHERE comp_guid = :id', array("id" => "$clientID"));
                        $decodedObj->computerName = $computerDetails["computer_name"];
                        $decodedObj->workgroup = $computerDetails["workgroup"];
                        $taskStatus = Custom_TaskManagement::getTaskStatus($taskData["uuid"], $clientID);
                        $xmlRow->tasks->task->taskData = base64_encode($decodedObj->convert(Custom_TaskManagement::makeObject($taskData), true, $taskStatus["last_run_time"], array("computer" => "$clientID","$taskData[uuid]")));
                    }
                }
            }
            $db->update('cmdqueue', array("status" => "sended"), $db->quoteInto('id = ?', $row['id']));
        }
        $schema->clientID = $clientID;
        $debugMode = Zend::registry("debugMode");
        if ($debugMode == "logs") {
            $string .= date(DATE_ISO8601);
            $string .= "\n==============================\n";
            $string .= self::printRincedXML($schema, true);
            file_put_contents("output.log", $string, FILE_APPEND);
            unset($string);
        }
        self::printRincedXML($schema);
    }
    public function cmdTaskNew (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        if (! $this->checkRegistration($clientID)) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        foreach ($xml->clientCommand->tasks->task as $xRow) {
            $taskData = base64_encode(trim($xRow->taskData));
            $taskID = $xRow->taskID;
            $taskName = $xRow->taskName;
            $dataMD5 = md5($taskData);
            $oTaskData = new Custom_ObjToTbt();
            $taskType = $oTaskData->taskTypes[(int) $xRow->taskType];
            $row = array("guid" => $taskID , "data" => $taskData , "data_md5" => $dataMD5 , "task_name" => $taskName , "admin_task" => "No" , "task_type" => $taskType , "owner" => $clientID);
            try {
                $db->insert('tasks', $row);
            } catch (Exception $e) {
                var_dump($e);
            }
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    public function cmdTaskEdit (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        if (! $this->checkRegistration($clientID)) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        /*$taskData = trim($xRow->taskData);
        $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
        $result = $db->fetchAssoc($taskSelect);
        if (count($result) > 0) {
        $method = "UPDATE";
        $row = current($result);
        Custom_TaskManagement::updateTask($row["id"], $taskData);*/
        foreach ($xml->clientCommand->tasks->task as $xRow) {
            $taskData = trim($xRow->taskData);
            $taskID = $xRow->taskID;
            $taskName = $xRow->taskName;
            $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID)->where('admin_task = ?', 'No');
            $result = $db->fetchAssoc($taskSelect);
            if (count($result) > 0) {
                $affectedRows = $db->update('tasks', array("task_name" => "$taskName" , 'data' => $taskData , 'data_md5' => md5($taskData)), $db->quoteInto('guid = ?', $taskID));
            } else {
                $oTaskData = new Custom_ObjToTbt();
                $taskType = $oTaskData->taskTypes[(int) $xRow->taskType];
                $row = array("guid" => $taskID , "data" => $taskData , "data_md5" => md5($taskData) , "task_name" => $taskName , "admin_task" => "No" , "task_type" => $taskType , "owner" => $clientID);
                $db->insert('tasks', $row);
            }
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    public function cmdTaskDelete (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        if (! $this->checkRegistration($clientID)) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        foreach ($xml->clientCommand->tasks->task as $xRow) {
            $z = $db->delete('tasks', $db->quoteInto('guid = ?', $xRow->taskID) . ' AND ' . $db->quoteInto('admin_task = ?', 'No'));
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    public function cmdTaskUpdate (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        //$row = $xml->clientCommand->tasks->task;
        foreach ($xml->clientCommand->tasks->task as $xRow) {
            $taskID = $xRow->taskID;
            $status = $xRow->status;
            $percentage = $xRow->percentage;
            $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
            $compSelect = $db->select()->from('computers')->where('comp_guid = ?', $clientID);
            $taskResult = $db->fetchAssoc($taskSelect);
            $compResult = $db->fetchAssoc($compSelect);
            if (count($compResult) == 0) {
                $this->generateError('CLIENT_ERROR', 'The specified clientID dosn\'t exist');
                return true;
            }
            if (count($taskResult) == 0) {
                $this->generateError('CLIENT_ERROR', 'The specified task dosn\'t exist.');
                return true;
            }
            Custom_TaskManagement::setTaskStatus($taskID, $status, $percentage, $clientID);
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    public function cmdTaskStart (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        //$row = $xml->clientCommand->tasks->task;
        $actionType = $xml->clientCommand->actionType;
        foreach ($xml->clientCommand->tasks->task as $xRow) {
            $taskID = $xRow->taskID;
            $status = $xRow->status;
            $percentage = 0;
            $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
            $compSelect = $db->select()->from('computers')->where('comp_guid = ?', $clientID);
            $taskResult = $db->fetchAssoc($taskSelect);
            $compResult = $db->fetchAssoc($compSelect);
            if (count($compResult) == 0) {
                $this->generateError('CLIENT_ERROR', 'The specified clientID dosn\'t exist');
                return true;
            }
            if (count($taskResult) == 0) {
                $this->generateError('CLIENT_ERROR', 'The specified task dosn\'t exist.');
                return true;
            }
            Custom_TaskManagement::setTaskStatus($taskID, $status, $percentage, $clientID, true);
            switch ($actionType) {
                case 'USER-STARTED':
                    if ($status == "Backup")
                        Logger::Log(3, 0, $taskID, $clientID); elseif ($status == "Restore")
                        Logger::Log(8, 0, $taskID, $clientID); elseif ($status == "Sync")
                        Logger::Log(12, 0, $taskID, $clientID); else
                        Logger::Log(0, 0, $taskID, $clientID, "Unknown status", $xml->asXML());
                    break;
                case 'SERVER-STARTED':
                    if ($status == "Backup")
                        Logger::Log(2, 0, $taskID, $clientID); elseif ($status == "Restore")
                        Logger::Log(7, 0, $taskID, $clientID); elseif ($status == "Sync")
                        Logger::Log(12, 0, $taskID, $clientID); else
                        Logger::Log(0, 0, $taskID, $clientID, "Unknown status");
                    break;
                case 'SCHEDULED':
                    if ($status == "Backup")
                        Logger::Log(1, 0, $taskID, $clientID); elseif ($status == "Restore")
                        Logger::Log(9, 0, $taskID, $clientID); elseif ($status == "Sync")
                        Logger::Log(12, 0, $taskID, $clientID); else
                        Logger::Log(0, 0, $taskID, $clientID, "Unknown status");
                    break;
                default:
                    Logger::Log(0, 0, $taskID, $clientID, "Unknown action type");
                    break;
            }
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    
    public function cmdCompSetValue (&$xml) {
        $clientID = $xml->clientID;
        $taskID = $xml->clientCommand->taskID;

        foreach ($xml->clientCommand->variable as $variable) {
            $varName = $variable->name;
            $value = $variable->value;
            CompSpace::set($clientID, $taskID, $varName, $value);
        }
        
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    
    public function cmdTaskEndReport (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        //$row = $xml->clientCommand->tasks->task;
        foreach ($xml->clientCommand->tasks->task as $xRow) {
            $taskID = $xRow->taskID;
            $status = 'Stopped';
            $percentage = 0;
            $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
            $compSelect = $db->select()->from('computers')->where('comp_guid = ?', $clientID);
            $taskResult = $db->fetchAssoc($taskSelect);
            $compResult = $db->fetchAssoc($compSelect);
            if (count($compResult) == 0) {
                $this->generateError('CLIENT_ERROR', 'The specified clientID dosn\'t exist');
                return true;
            }
            if (count($taskResult) == 0) {
                $this->generateError('CLIENT_ERROR', 'The specified task dosn\'t exist.');
                return true;
            }
            //Custom_TaskManagement::setTaskStatus($taskID, $status, $percentage, $clientID, NULL, true, true, (string) $xRow->Report->NextRunTime);
            Custom_TaskManagement::setTaskStatus($taskID, $status, $percentage, $clientID, NULL, true, true, (string) $xRow->Report->NextRunTime, "no");
            /* Report Wise */
            $logType = $xRow->Report->LogType;
            $logTempTime = $xRow->Report->Time;
            $logStatus = $xRow->Report->Status;
            $logSumary = base64_decode($xRow->Report->Summary);
            $logDetails = base64_decode($xRow->Report->Details);
            Logger::Log((int) $logType, (int) $logStatus, $taskID, $clientID, $logSumary, $logDetails);
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        self::printRincedXML($schema);
    }
    public function cmdRegister (&$xml)
    {
        $uuid = $this->makeUUID();
        $db = Zend::registry('dbController');
        $computerName = $xml->clientCommand->computerName;
        //$ip = $xml->clientCommand->computerIP;
        $ip = $_SERVER['REMOTE_ADDR'];
        $workgroup = $xml->clientCommand->computerWorkgroup;
        $users = $xml->clientCommand->extras->users;
        $select = $db->select()->from('computers')->where('computer_name = ?', $computerName)->where('workgroup = ?', $workgroup);
        $result = $db->fetchAssoc($select);
        if (count($result) > 0) {
            /*$schema = Custom_XMLSchemas::getHeader();
            $taskSchema = constant("Custom_XMLSChemas::XML_RESPONSE_REGISTER_FAIL");
            $newCommand = simplexml_load_string($taskSchema);
            Custom_XMLSchemas::simplexml_append($schema, $newCommand);
            $schema->statusMSG = "Computer already exists in the database";
            echo($schema->asXML());
            return;*/
            $db->delete('computers', $db->quoteInto('computer_name = ?', $computerName));
        }
        $ownerMail = $xml->clientCommand->ownerEmail;
        $insert = array("comp_guid" => "$uuid" , "workgroup" => "$workgroup" , "ip" => "$ip" , "computer_name" => $computerName , "status" => "pending" , "client_version" => "$xml->clientVersion" , "owner_email" => "$ownerMail");
        if (Options::get('auto_approve') == "true") {
            $insert['status'] = 'approved';
        } else {
            Custom_Mail::newComputerMail($insert);
        }
        $db->insert('computers', $insert);
        //foreach ($users->user as $user) {
        //    $userName = (string) $user;
        //    $insert = array("name" => "$userName" , "computer_id" => "$uuid");
        //    $db->delete('users', $db->quoteInto('name = ?', $userName));
        //    $db->insert('users', $insert);
        //}
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_REGISTER_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        $schema->addChild('clientID', $uuid);
        self::printRincedXML($schema);
    }
    public function makeUUID ()
    {
        $db = Zend::registry('dbController');
        $uuid = Custom_TaskManagement::uuid();
        $select = $db->select()->from('computers')->where('comp_guid = ?', $uuid);
        $result = $db->fetchAssoc($select);
        if (count($result) > 0) {
            return $this->makeUUID();
        } else {
            return $uuid;
        }
    }
    public function cmdRestoreResponse (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        $taskID = $xml->tasks->task->taskID;
        $status = $xml->tasks->task->status;
        if ($this->checkRegistration($clientID) == false) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        Custom_TaskManagement::setTaskStatus($taskId, $status, 0, $clientID);
        $response = $xml->status;
        if ($response == "Restore")
            Logger::Log(7, 0, $taskID, $clientID); else
            Logger::Log(7, 2, $taskID, $clientID, "User canceled.");
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        $schema->addChild('clientID', $clientID);
        self::printRincedXML($schema);
    }
    public function cmdRefresh (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        $clientOptions = $xml->clientCommand->clientOptions->asXML();
        if ($this->checkRegistration($clientID) == false) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        $db->update('computers', array("options" => base64_encode($clientOptions)), $db->quoteInto("comp_guid = ? ", $clientID));
        $tasks = $xml->clientCommand->tasks->task;
        $db->delete('tasks', "admin_task = 'No' AND owner = '$clientID'");
        foreach ($tasks as $xRow) {
            $taskID = $xRow->taskID;
            $taskStatus = $xRow->status;
            $taskProgress = $xRow->progress;
            $taskData = trim($xRow->taskData);
            $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
            $result = $db->fetchAssoc($taskSelect);
            $oTaskData = new Custom_ObjToTbt();
            $taskType = $oTaskData->taskTypes[(int) $xRow->taskType];
            if (count($result) > 0) {
                $method = "UPDATE";
                $row = current($result);
                $taskName = $xRow->taskName;
                $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID)->where('admin_task = ?', 'No');
                $result = $db->fetchRow($taskSelect);
                try {
                    $affectedRows = $db->update('tasks', array("task_name" => "$taskName" , 'data' => $taskData , 'data_md5' => md5($taskData) , "task_type" => $taskType), $db->quoteInto('guid = ?', $taskID));
                } catch (Exception $e) {
                    var_dump($e);
                }
            } else {
                $method = "INSERT";
                $dataMD5 = md5($taskData);
                $taskName = $xRow->taskName;
                $row = array("guid" => $taskID , "data" => $taskData , "data_md5" => md5($taskData) , "task_name" => $taskName , "admin_task" => "No" , "task_type" => $taskType , "owner" => $clientID);
                try {
                    $db->insert('tasks', $row);
                } catch (Exception $e) {
                    var_dump($e);
                }
            }
            Custom_TaskManagement::setTaskStatus($taskID, $taskStatus, $taskProgress, $clientID);
        }
        $schema = Custom_XMLSchemas::getHeader();
        $taskSchema = constant("Custom_XMLSchemas::XML_RESPONSE_REGISTER_OK");
        $newCommand = simplexml_load_string($taskSchema);
        Custom_XMLSchemas::simplexml_append($schema, $newCommand);
        $schema->addChild('clientID', $uuid);
        self::printRincedXML($schema);
    }
    public function sendNoop (&$xml)
    {}
    public function createResponse (&$xml)
    {}
    public function checkRegistration ($guid)
    {
        $db = Zend::registry('dbController');
        $select = $db->select()->from('computers')->where('comp_guid = ?', $guid);
        $result = $db->fetchRow($select);
        if (! $result)
            return false;
        if ($result["status"] != "approved")
            return false;
        return true;
    }
    function verifyClient (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        $select = $db->select()->from('computers')->where('comp_guid =?', $clientID);
        $result = $db->fetchRow($select);
        if ($result == false)
            $nonExistant = true; else
            $nonExistant = false;
        $gId = $result['comp_guid'];
        $oXml = new SimpleXMLElement('<commands></commands>');
        if ($nonExistant) {
            $oXml->addChild('serverCommand')->addChild('name', 'INVALID-ID');
            $oXml->serverCommand->addChild('clientID', 'none');
            $oXml->serverCommand->addChild('approved', ($result['status'] == "approved" ? "true" : "false"));
        } else {
            $oXml->addChild('serverCommand')->addChild('name', 'VALID-ID');
            $oXml->serverCommand->addChild('clientID', $gId);
            $oXml->serverCommand->addChild('approved', ($result['status'] == "approved" ? "true" : "false"));
        }
        self::printRincedXML($oXml);
        return true;
    }
    function generateError ($error_type, $error_msg)
    {
        $XML_SCHEMA = '<commands><serverCommand><name/><statusMsg/></serverCommand></commands>';
        $xml = new SimpleXMLElement($XML_SCHEMA);
        $xml->serverCommand->type = "ERROR";
        $xml->serverCommand->name = "$error_type";
        $xml->serverCommand->statusMsg = "$error_msg";
        self::printRincedXML($xml);
    }
    // Fix temporar pentru sergiu
    /*    function resyncData(&$xml) {
    $db = Zend::registry('dbController');
    $clientID = $xml->clientID;

    $clientOptions = $xml->clientCommand->clientOptions->asXML();

    if ($this->checkRegistration($clientID) == false) {
    $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
    return;
    }


    $ownerMail = $xml->clientCommand->ownerEmail;
    $db->update('computers', array("options" => base64_encode($clientOptions),
    "owner_email" => "$ownerMail"),
    $db->quoteInto("comp_guid = ? ", $clientID));


    $tasks = $xml->clientCommand->tasks->task;
    $db->delete('tasks', "admin_task = 'No' AND owner = '$clientID'");
    foreach ($tasks as $xRow) {
    $taskID = $xRow->taskID;
    $taskStatus = $xRow->status;
    $taskProgress = $xRow->progress;
    $taskData = trim($xRow->taskData);
    $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
    $result = $db->fetchAssoc($taskSelect);

    $oTaskData = new Custom_ObjToTbt();
    $taskType = $oTaskData->taskTypes[(int)$xRow->taskType];


    if (count($result) > 0) {
    $method = "UPDATE";
    $row = current($result);

    $taskName = $xRow->taskName;
    $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID)->where('admin_task = ?', 'No');
    $result = $db->fetchRow($taskSelect);
    try {
    $affectedRows = $db->update('tasks', array("task_name" => "$taskName" ,'data' => $taskData, 'data_md5' => md5($taskData), "task_type" => $taskType), $db->quoteInto('guid = ?', $taskID));
    } catch (Exception $e) {
    var_dump($e);
    }
    } else {
    $method = "INSERT";
    $dataMD5 = md5($taskData);
    $taskName = $xRow->taskName;

    $row = array("guid" => $taskID,
    "data" => $taskData,
    "data_md5" => md5($taskData),
    "task_name" => $taskName,
    "admin_task" => "No",
    "task_type" => $taskType,
    "owner" => $clientID);
    try {
    $db->insert('tasks', $row);
    } catch (Exception $e) {
    var_dump($e);
    }
    }
    Custom_TaskManagement::setTaskStatus($taskID, $taskStatus, $taskProgress, $clientID);
    }

    $schema = Custom_XMLSchemas::getHeader();
    $select = $db->select()->from('computers')->where('comp_guid = ?', $clientID)->limit(1);
    $compData = $db->fetchRow($select);
    $cs = new Custom_ComputerSelect();
    $tasks = $cs->getAdminTasks($compData['computer_name'], $compData['workgroup']);
    $schema->addChild('clientID', $compData['comp_guid']);
    $serverCommand = $schema->addChild('serverCommand');
    $serverCommand->addChild('name', 'RESYNC');
    $serverCommand->addChild('clientOptions', $compData['options']);
    $xTasks = $serverCommand->addChild('tasks');
    $decodedObj = new Custom_ObjToTbt();
    $decodedObj->computerName = $compData["computer_name"];
    $decodedObj->workgroup = $compData["workgroup"];
    foreach ($tasks as $task) {
    $xTask = $xTasks->addChild('task');
    $xTask->addChild('taskID', $task['guid']);
    $xTask->addChild('taskName', $task['task_name']);
    $xTask->addChild('taskData',  base64_encode($decodedObj->convert($task['data'], true)));
    }

    echo($schema->asXML());
    } */
    function resyncData (&$xml)
    {
        $db = Zend::registry('dbController');
        $clientID = $xml->clientID;
        $clientOptions = $xml->clientCommand->clientOptions->asXML();
        if ($this->checkRegistration($clientID) == false) {
            $this->generateError("QUERY_ERROR", "PC is not registered or it hasn't been Approved yet.");
            return;
        }
        $ownerMail = $xml->clientCommand->ownerEmail;
        $db->update('computers', array("options" => base64_encode($clientOptions) , "owner_email" => "$ownerMail"), $db->quoteInto("comp_guid = ? ", $clientID));
        $tasks = $xml->clientCommand->tasks->task;
        $db->delete('tasks', "admin_task = 'No' AND owner = '$clientID'");
        if (count($tasks) > 0) {
            foreach ($tasks as $xRow) {
                $taskID = $xRow->taskID;
                $taskStatus = $xRow->status;
                $taskProgress = $xRow->progress;
                $taskData = trim($xRow->taskData);
                $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID);
                $result = $db->fetchAssoc($taskSelect);
                $oTaskData = new Custom_ObjToTbt();
                $taskType = $oTaskData->taskTypes[(int) $xRow->taskType];
                if (count($result) > 0) {
                    $method = "UPDATE";
                    $row = current($result);
                    $taskName = $xRow->taskName;
                    $taskSelect = $db->select()->from('tasks')->where('guid = ?', $taskID)->where('admin_task = ?', 'No');
                    $result = $db->fetchRow($taskSelect);
                    try {
                        $affectedRows = $db->update('tasks', array("task_name" => "$taskName" , 'data' => $taskData , 'data_md5' => md5($taskData) , "task_type" => $taskType), $db->quoteInto('guid = ?', $taskID));
                    } catch (Exception $e) {
                        var_dump($e);
                    }
                } else {
                    $method = "INSERT";
                    $dataMD5 = md5($taskData);
                    $taskName = $xRow->taskName;
                    $row = array("guid" => $taskID , "data" => $taskData , "data_md5" => md5($taskData) , "task_name" => $taskName , "admin_task" => "No" , "task_type" => $taskType , "owner" => $clientID);
                    try {
                        $db->insert('tasks', $row);
                    } catch (Exception $e) {
                        var_dump($e);
                    }
                }
                Custom_TaskManagement::setTaskStatus($taskID, $taskStatus, $taskProgress, $clientID);
            }
        }
        $select = $db->select()->from('computers')->where('comp_guid = ?', $clientID)->limit(1);
        $compData = $db->fetchRow($select);
        $cs = new Custom_ComputerSelect();
        $tasks = $cs->getAdminTasks($compData['computer_name'], $compData['workgroup']);
        $schema = Custom_XMLSchemas::getHeader();
        $schema->addChild('clientID', $compData['comp_guid']);
        foreach ($tasks as $task) {
            $serverCommand = $schema->addChild('serverCommand');
            $serverCommand->addChild('name', 'RESYNC');
            $serverCommand->addChild('clientOptions', $compData['options']);
            $xTasks = $serverCommand->addChild('tasks');
            $decodedObj = new Custom_ObjToTbt();
            $decodedObj->computerName = $compData["computer_name"];
            $decodedObj->workgroup = $compData["workgroup"];
            $xTask = $xTasks->addChild('task');
            $xTask->addChild('taskID', $task['guid']);
            $xTask->addChild('taskName', htmlentities($task['task_name']));
            $taskStatus = Custom_TaskManagement::getTaskStatus($task['guid'], $compData['comp_guid']);
            $xTask->addChild('taskData', base64_encode($decodedObj->convert($task['data'], true, $taskStatus["last_run_time"], array("computer" => "$clientID", "task" => "$task[guid]"))));
        }
        self::printRincedXML($schema);
    }
}