<?php
/**
 * This is the main logging class.
 * Its used to log server/client events in the databse.
 *
 */
class Logger
{
    /**
     * The main log function
     *
     * @param int $logType
     * @param int $status
     * @param string $taskID
     * @param string $computerID
     * @param string $summary
     * @param string $details
     */
    static public function Log ($logType, $status, $taskID, $computerID, $summary = NULL, $details = NULL)
    {
        $db = Zend::registry('dbController');
        /*
        Log Types: 0 Unknown
                   1 Start Scheduled
                   2 Start Server
                   3 Start Client
                   4 End Report
                   5 Stop Server
                   6 Stop Client
                   7 Restore Server
                   8 Restore Client
                   9 Restore End Report
                   10 Missed Report
                   11 Server Side
        */
        /* 
        Status Types:
                        0 Success
                        1 Warnings
                        2 Errors
                        3 Missed
        */
        $row = array("log_type_id" => $logType , "time" => strftime('%Y-%m-%d %H:%M:%S', time(0)) , "status" => $status , "task_id" => $taskID , "computer_id" => $computerID);
        if ($summary != NULL)
            $row['summary'] = $summary;
        if ($details != NULL)
            $row['details'] = $details;
        $db->insert('logs', $row);
    }
}