<?php
class Options
{
    static public function set ($key, $value)
    {
        $db = Zend::registry('dbController');
        $select = $db->select()->from('options')->where('option_key = ?', $key);
        $result = $db->fetchRow($select);
        if ($result == false) {
            $db->insert('options', array("option_key" => $key , "option_value" => base64_encode(serialize($value))));
        } else {
            $db->update('options', array("option_value" => base64_encode(serialize($value))), $db->quoteInto('option_key = ?', $key));
        }
        return $value;
    }
    static public function get ($key)
    {
        $db = Zend::registry('dbController');
        $select = $db->select()->from('options')->where('option_key = ?', $key);
        $result = $db->fetchRow($select);
        if ($result != false)
            return unserialize(base64_decode($result['option_value']));
        return NULL;
    }
    static public function unsetvar ($key)
    {
        $db = Zend::registry('dbController');
        return $db->delete('options', $db->quoteInto('option_key = ?', $key));
    }
    static public function setDefaults ($force = false)
    {
        $defaults = array("refresh_time" => 10 , "firstRun" => true);
        foreach ($defaults as $key => $value) {
            if ($force == true) {
                self::set($key, $value);
            } else {
                if (self::get($key) === NULL) {
                    self::set($key, $value);
                }
            }
        }
        return true;
    }
    static public function getAll ()
    {
        $db = Zend::registry('dbController');
        $select = $db->select()->from('options');
        $result = $db->fetchAll($select);
        $options = array();
        foreach ($result as $row) {
            $options["$row[option_key]"] = unserialize(base64_decode($row['option_value']));
        }
        return $options;
    }
}